#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

const int dx[4] = { -1, 1, 0, 0 };
const int dy[4] = { 0, 0, -1, 1 };
char walls[1024][1024];
int width, height;
int queue[1048576];
int depth[1024][1024], maxPath[1024][1024];

int main()
{
	char line[1024];
	int nCases, x, y, head, tail, i, j, x2, y2; 
	gets(line); sscanf(line, "%d", &nCases);
	while (nCases-- > 0)
	{
		gets(line); sscanf(line, "%d %d", &width, &height);
		for (x = 0; x < width + 2; x++)
			walls[0][x] = 1, walls[height + 1][x] = 1;
		for (y = 0; y < height + 2; y++)
			walls[y][0] = 1, walls[y][width + 1] = 1;
//		memset(walls, 1, sizeof(walls)); 
		head = tail = 0;
//		memset(depth, 0, sizeof(depth)); memset(maxPath, 0, sizeof(maxPath));
		for (y = 0; y < height; y++)
		{
			gets(line); memset(&(walls[y+1][1]), 1, width);
			for (x = 0; x < width; x++) if (line[x] == '.')
			{
				walls[y+1][x+1] = 0; depth[y+1][x+1] = 0;
				maxPath[y+1][x+1] = 0;
				if (tail == 0) queue[tail++] = ((y+1) << 10) | (x+1);
			}
		}
		if (head == tail)
		{
			printf("Maximum rope length is 0.\n");
			continue;
		}
		while (head < tail)
		{
			i = queue[head++]; x = i & 1023; y = i >> 10;
	//		printf("R(%d, %d) ", x, y);
			walls[y][x] = 2;
			for (j = 0; j < 4; j++) 
			{
				x2 = x + dx[j]; y2 = y + dy[j];
				if (walls[y2][x2] == 0)
					queue[tail++] = (y2 << 10) | x2,
					walls[y][x] |= 1 << (4 + j);
			}
		}
//		printf("\n");
		for (i = tail - 1; i >= 0; i--)
		{
			int q = queue[i]; x = q & 1023; y = q >> 10;
			//printf("Q(%d, %d) ", x, y);
			char w = walls[y][x];
			int dp1 = -1, dp2 = -1, anyChildren = ((w & 0xF0) ? 1 : 0), mp = 0;
			if (anyChildren) 
			{
			for (j = 0; j < 4; j++) if ((w >> (j + 4)) & 1) // (w & (1 << (j + 4)))
			{
				x2 = x + dx[j]; y2 = y + dy[j]; assert(walls[y2][x2] != 1);
				{
//					printf("c(%d,%d)->p(%d,%d) ", x2, y2, x, y);
					if (maxPath[y2][x2] > mp) mp = maxPath[y2][x2];
					int d = depth[y2][x2];
					if (d >= dp2) dp1 = dp2, dp2 = d;
					else if (d > dp1) dp1 = d;
				}
			}
			assert(dp2 >= 0); assert(dp2 >= dp1);
			if (dp1 >= 0 && dp2 >= 0) if (mp < dp1 + dp2 + 2) mp = dp1 + dp2 + 2;
			if (dp2 >= 0) if (mp < dp2 + 1) mp = dp2 + 1;
			maxPath[y][x] = mp; depth[y][x] = (dp2 >= 0) ? (dp2 + 1) : 0;
			}
			else
			{ // no children
				maxPath[y][x] = 0; depth[y][x] = 0;
			}
		} // for i
		x = queue[0] & 1023; y = queue[0] >> 10;
		printf("Maximum rope length is %d.\n", maxPath[y][x]);
	}
	return 0;
}